//
// Defines (kinda)
//

static short ICON_INFO      = 301;
static short ICON_OLD       = 302;
static short ICON_BEHIND    = 303;
static short ICON_STORY     = 304;
static short ICON_MODEL     = 305;
static short ICON_ANIMATIC  = 306;
static short ICON_NEW       = 307;
static short ICON_BEHIND2   = 315;
static short ICON_BEHIND3   = 316;
static short ICON_ANIMATIC2 = 317;
static short ICON_MODEL2    = 318;
static short ICON_BEHIND4   = 319;

public short ICON_BACK     = 311;
public short ICON_CONTROL  = 312;
public short ICON_FORWARD  = 313;
public short ICON_UP       = 314;

public short ICON_FIRST = ICON_INFO;
public short ICON_LAST  = ICON_BEHIND4;

static short NUM_SCREENS	= 4;
static short NUM_BUTTONS	= 12;

static short RETVAL_INFO	= -1;
static short RETVAL_STORY	= -2;
static short RETVAL_FINAL	= -3;

//-----------------------
//
// Button Descriptors
//
//-----------------------

short scene_buttons[ NUM_SCREENS * NUM_BUTTONS ] = {

	ICON_INFO, ICON_OLD,		ICON_STORY,		ICON_ANIMATIC,  ICON_BEHIND,	ICON_NEW,		0, 				0,	0,	0,0,0,
	ICON_MODEL,ICON_MODEL2,	ICON_ANIMATIC,	ICON_ANIMATIC2, ICON_BEHIND,  ICON_BEHIND2,	ICON_BEHIND3, ICON_NEW, ICON_INFO, ICON_OLD, ICON_STORY,0,
	ICON_INFO, ICON_OLD,		ICON_STORY,		ICON_BEHIND,	 ICON_BEHIND2,	ICON_NEW, 		0,					0,	0,	0,0,0,
	ICON_INFO, ICON_OLD,		ICON_BEHIND,	ICON_BEHIND2,	 ICON_BEHIND3,	ICON_BEHIND4,	ICON_NEW,		0,	0,	0,0,0
};

//-----------------------
//
// handle_button()
//
//-----------------------

uchar handle_button( short selection )
{
	short error;

	anim_setrate(15);

	sound_stopall();
	button_down(0);

	if (current_menu==MENU_TATOOINE)	{
		error = ta_play( selection );
	}

	else if (current_menu==MENU_MOSEISLY) {
		error = me_play( selection );
	}

	else if (current_menu==MENU_JABBAHAN) {
		error = jb_play( selection );
	}

	else if (current_menu==MENU_FINALBAT) {
		error = fb_play( selection );
	}

	//
	// Do Special-Case submenus
	//

	if (error==RETVAL_INFO) {
		view_goto( "NewSeqInfo Menu" );
		return 0;
	}

	if (error==RETVAL_STORY) {
		view_goto("SubBoard Menu");
		for ( menu_up_flag = FALSE; !menu_up_flag; sleep() );
		view_goto("SubNseq Menu");
		return 0;
	}

	if (error==RETVAL_FINAL) {
		view_goto("Finals Menu");
		for ( menu_up_flag = FALSE; !menu_up_flag; sleep() );
		view_goto("SubNseq Menu");
		return 0;
	}

	//
	// Else play animation and wait for it
	//

	if (!error) {
		icon_reset();
   	mouse_set(FALSE); 
	   sleep();
		while (anim_query() && keyboard_read()!=27 ) {
			if (keyboard_read()==' ') {
				display_set( 0, (display_get(0)+1)%3 );
			}
			sleep();
		}
		if (keyboard_read()==27) sound_stopall();

		mouse_set(TRUE);
	}

	//
	// Refresh menus and stuff
	//

	anim_setrate(15);
	start_up();
}

//-----------------------
//
// start_up()
//
//-----------------------

uchar start_up()
{
	short i,k;


	//
	// Set icons appropriately
	//

   icon_reset();

   icon_add( ICON_CONTROL, 0 );
	icon_add( ICON_UP,      0 );

	if (current_menu!=MENU_TATOOINE)	{
		icon_add( ICON_BACK, 0 );
		button_set( "back", 0,0 );
	} else {
		button_set( "back", 1,0 );
	}

	if (current_menu!=MENU_FINALBAT)	{
		icon_add( ICON_FORWARD, 0 );
		button_set( "forward", 0,0 );
	} else {
		button_set( "forward", 1,0 );
	}

	k = NUM_BUTTONS * current_menu;

	button_set( "button 1", 1,0 );
	button_set( "button 2", 1,0 );
	button_set( "button 3", 1,0 );
	button_set( "button 4", 1,0 );
	button_set( "button 5", 1,0 );
	button_set( "button 6", 1,0 );
	button_set( "button 7", 1,0 );
	button_set( "button 8", 1,0 );

	button_set( "button 9", 1,0 );
	button_set( "button 10", 1,0 );
	button_set( "button 11", 1,0 );
	button_set( "button 12", 1,0 );

	for (i=0; i<NUM_BUTTONS && scene_buttons[k+i]; i+=1) {
		
      icon_add( scene_buttons[k+i], i );

	}

	//
	// If not returning from control panel...
	//

//   if (!pan_quit_flag) {

		//
		// Restart background animation
		//

		if (current_menu==MENU_TATOOINE)	{
			anim_start("data\tatooine\ta_menu.san",ONCE,NEWPAL);
		}

		else if (current_menu==MENU_MOSEISLY) {
			anim_start("data\moseisly\me_menu.san",ONCE,NEWPAL);
		}

		else if (current_menu==MENU_JABBAHAN) {
			anim_start("data\jabbahan\jb_menu.san",ONCE,NEWPAL);
		}

		else if (current_menu==MENU_FINALBAT) {
			anim_start("data\finalbat\fb_menu.san",ONCE,NEWPAL);
		}

//	}
	pan_quit_flag = FALSE;
}


short ta_play( short choice )
{
	if (choice==0) { return RETVAL_INFO;  }
	if (choice==2) { return RETVAL_STORY; }

	if      (choice==1) anim_start("data\tatooine\ta_bef.san",ONCE,NEWPAL|HALTAUDIO);
	else if (choice==3) anim_start("data\tatooine\ta_an.san", ONCE,NEWPAL|HALTAUDIO);
	else if (choice==4) anim_start("data\tatooine\ta_bs.san", ONCE,NEWPAL|HALTAUDIO);
	else if (choice==5) anim_start("data\tatooine\ta_fin.san",ONCE,NEWPAL|HALTAUDIO);
	else return -1;
	return 0;
}

short me_play( short choice )
{
	if (choice==8 ) { return RETVAL_INFO;  }
	if (choice==10) { return RETVAL_STORY; }

	if (choice==9 ) anim_start("data\moseisly\me_bef.san",ONCE,NEWPAL|HALTAUDIO);

	else if (choice==0) anim_start("data\moseisly\me_an5.san",ONCE,NEWPAL|HALTAUDIO);
	else if (choice==1) anim_start("data\moseisly\me_an7.san",ONCE,NEWPAL|HALTAUDIO);
	else if (choice==2) anim_start("data\moseisly\me_an.san", ONCE,NEWPAL|HALTAUDIO);
	else if (choice==3) anim_start("data\moseisly\me_an6.san",ONCE,NEWPAL|HALTAUDIO);
	else if (choice==4) anim_start("data\moseisly\me_gl.san" ,ONCE,NEWPAL|HALTAUDIO);
	else if (choice==5) anim_start("data\moseisly\me_bs2.san",ONCE,NEWPAL|HALTAUDIO);
	else if (choice==6) anim_start("data\moseisly\me_gdo.san",ONCE,NEWPAL|HALTAUDIO);
	else if (choice==7) anim_start("data\moseisly\me_fin.san",ONCE,NEWPAL|HALTAUDIO);
	else return -1;
	return 0;
}

short jb_play( short choice )
{
	if (choice==0) { return RETVAL_INFO;  }
	if (choice==2) { return RETVAL_STORY; }

	if      (choice==1) anim_start("data\jabbahan\jb_bef.san",ONCE,NEWPAL|HALTAUDIO);
	else if (choice==3) anim_start("data\jabbahan\jb_gl.san", ONCE,NEWPAL|HALTAUDIO);
	else if (choice==4) anim_start("data\jabbahan\jb_bs.san", ONCE,NEWPAL|HALTAUDIO);
	else if (choice==5) anim_start("data\jabbahan\jb_fin.san",ONCE,NEWPAL|HALTAUDIO);
	else return -1;
	return 0;
}



short fb_play( short choice )
{
	if (choice==0) { return RETVAL_INFO;  }

	if 	  (choice==1) anim_start("data\finalbat\fb_bef.san",  ONCE,NEWPAL|HALTAUDIO);
	else if (choice==2) anim_start("data\tatooine\ta_trans.san",ONCE,NEWPAL|HALTAUDIO);
	else if (choice==3) anim_start("data\finalbat\fb_gl.san",  ONCE,NEWPAL|HALTAUDIO);
	else if (choice==4) anim_start("data\finalbat\fb_bs1.san", ONCE,NEWPAL|HALTAUDIO);
	else if (choice==5) anim_start("data\finalbat\fb_bs2.san", ONCE,NEWPAL|HALTAUDIO);
	else if (choice==6) anim_start("data\finalbat\fb_fin.san", ONCE,NEWPAL|HALTAUDIO);
	else return -1;
	return 0;
}

